#include <stdio.h>
#include <stdlib.h>

#define NMAX 5000

/* legge i valori dallo standard input e li mette nel vettore v.
 * La funzione restituisce il numero di elementi presenti nel vettore.
 */
int leggi_vettore(int *v);

/* si noti che il parametro per il vettore puo` essere scritto come int v* oppure int v[].
 * Si noti come, a differenza di quanto avviene per le stringhe,
 * bisogna utilizzare una variabile atta a memorizzare la dimensione dell'array.
 * Le stringhe sono automaticamente terminate dal carattere nullo, i vettori non hanno
 * terminatore.
 */
void bubblesort(int v[], int n);

/* esegue un ciclo di printf per stampare ogni elemento.
 * Utilizzo lo specificatore const per sottolineare che il vettore non viene modificato
 * dalla funzione.
 */
void stampa_vettore(const int v[], int dim);

int main()
{
	int dim; /* dimensione desiderata */
	int v[NMAX]; /* vettore di interi da ordinare */

	/* in dim trovero` la dimensione del vettore. v e` il puntatore al primo elemento
	 * del vettore. Viene passata una copia del puntatore, ma il puntatore contiene
	 * l'indirizzo in memoria del primo elemento. Quindi, la funzione modifica il 
	 * contenuto di v.
	 */
	dim = leggi_vettore(v);

	bubblesort(v, dim);

	stampa_vettore(v, dim);
	
	return EXIT_SUCCESS;
}

void bubblesort(int v[], int dim)
{
	int i; /* indice vettore */
	int temp; /* variabile temporanea per effettuare lo scambio */
	char scambiato; /* flag che, se > 0, indica che e` avvenuto uno scambio */
	/* il vettore v contiene nei primi dim elementi gli interi desiderati */
	do
	{
		scambiato = 0;
		for(i = 0; i < dim - 1; i++)
		{
			if(v[i + 1] < v[i])
			{
				scambiato = 1;
				temp = v[i];
				v[i] = v[i + 1];
				v[i + 1] = temp;
			}
		}
	}while(scambiato);

}

int leggi_vettore(int *v)
{
	int i, dim;
	printf("Inserisci il numero di elementi desiderato: ");
	scanf("%d", &dim);
	printf("Inserisci ciascun elemento seguito da invio:\n");
	/* riempio il vettore con gli interi desiderati */
	for(i = 0; i < dim; i++)
	{
		printf("v[%d] = ", i);
		scanf("%d", v + i);
		/* equivalente a */
		// scanf("%d", &v[i]);
	}

}

void stampa_vettore(const int v[], const int dim)
{
	int i;
	printf("\n{ ");
	for(i = 0; i < dim; i++)
		printf("%d, ", v[i]);
	printf("\b\b }\n");
}

