#include <stdio.h>
#include <stdlib.h>

#define MAXROWS 100
#define MAXCOLS 100

/* prototipi funzioni usate. Si noti che quando si passa una matrice, sono valide entrambe le forme
 * m[][MAXCOLS] e
 * m[MAXROWS][MAXCOLS]
 * L'importante e` che il compilatore sappia il numero di colonne.
 */
void stampa_matrice(double m[][MAXCOLS], int rows, int cols);

/* mat_prod conterra` il prodotto delle due matrici m2 e m1.
 * Essendo m1, m2, mat_prod puntatori, la memoria tra il chiamante (main) e la funzione e` condivisa.
 * La funzione quindi effettivamente modifica la matrice.
 */
void prodotto(double m1[MAXROWS][MAXCOLS], double m2[MAXROWS][MAXCOLS], int r1, int r2, int c1, int c2, double mat_prod[MAXROWS][MAXCOLS]);

void stampa_matrice(double m[][MAXCOLS], int rows, int cols)
{
	int i, j;
	printf("matrice %dx%d\n", rows, cols);
	for(i = 0; i < rows; i++)
	{
		for(j = 0; j < cols; j++)
			printf("%.2f\t\t", m[i][j]);
		printf("\n");
	}
	printf("\n");
}

void prodotto(double m1[MAXROWS][MAXCOLS], double m2[MAXROWS][MAXCOLS], int r1, int r2, int c1, int c2, double mat_prod[MAXROWS][MAXCOLS])
{
	int i;
	int pr; /* contatore di riga della matrice prodotto */
	int pc; /* contatore di colonna della matrice prodotto */
	int rp = r1; /* numero di righe della matrice prodotto */
	int cp = c2; /* numero di colonne della matrice prodotto */
	
	for(pr = 0; pr < rp; pr++)
	{
		for(pc = 0; pc < cp; pc++)
		{
			for(i = 0; i < rp; i++)
				mat_prod[pr][pc] += m1[pr][i] * m2[i][pc];
		}
	}
}

int main()
{
	int r1 = 4, c1 = 4, r2 = 4, c2 = 2;
	double m1[MAXROWS][MAXCOLS] = { { 1, -1, 3, -9 }, { 1, -2, 5, -4 }, { 3, 2, 4, -11 }, { 10, -6, -8, -0.5} };
	double m2[MAXROWS][MAXCOLS] = { { 2, -2 }, { 5, -1 }, { 6, 1 }, { -1.2, -0.5} }; 
	double p[MAXROWS][MAXCOLS]; /* conterra` il prodotto */
	
	stampa_matrice(m1, r1, c1);
	stampa_matrice(m2, r2, c2);

	prodotto(m1, m2, r1, c1, r2, c2, p);

	stampa_matrice(p, r1, c2);

	return EXIT_SUCCESS;

}


