/****Questo programma riceve una sequenza di numeri che verranno ordinati
  in una matrice dell'ordine specificato.I numeri verranno inseriti
  tenendo conto che saranno ordinati dall'alto verso il basso
  per righe e colonne da   sinistra verso destra****/

#include<stdio.h>
#include<stdlib.h>

#define R 100
#define C 100

void visualizza_matrice(float m[R][C], int x, int y);

void leggi_matrice(float m[R][C], int *numrows, int *numcols);

/* implementa il metodo di Gauss-Jordan per la riduzione della matrice
 * a forma triangolare superiore.
 */
void gauss(float m[R][C], int righe, int colonne);

int scambiariga(float m[R][C], int riga, int righe, int colonne);

void diagonale_unitaria(float m[R][C], int riga, int colonna);

int minimo(int a, int b);

int main(int argc, char **argv)
{
	int r;
	int c;
	float m[R][C];

	leggi_matrice(m, &r, &c);

	visualizza_matrice(m, r, c);

	gauss(m, r, c);

	visualizza_matrice(m, r, c);

	diagonale_unitaria(m, r, c);

	visualizza_matrice(m, r, c);

	return EXIT_SUCCESS;

}

void leggi_matrice(float m[R][C], int *r, int *c)
{
	int i;
	int j;

	printf("inserisci num righe, num colonne, separate da virgola, ad es 3, 3\n");
	scanf("%d, %d", r, c);
	printf("inserisci i numeri facendoli seguire da invio, in ordine (0,0);  (0,1); (0,2)...(1,0); (1,1); (1,2);...\n");
	for(i = 0; i < *r; i++)
	{
		for(j = 0; j < *c; j++)
		{
			printf("m[%d][%d]= ", i, j);
			scanf("%f", &m[i][j]);
		}
	}
}

void visualizza_matrice( float m[R][C], int r, int c)
{
	int i=0;
	int j=0;

	printf("\nMatrice %dx%d\n", r, c);

	for(i=0; i<r; i++)
	{
		for(j=0;j<c; j++)
			printf("%.3f\t\t", m[i][j]);
		printf("\n\n");
	}
}

void gauss(float a[R][C], int numrows, int numcols)
{
	float coeff;
	int next_row;
	int prev_row;
	int row;
	int column;
	/* variabile che indica se devo procedere ad annullare gli elementi
	 * sotto a[l][l], elemento appartenente alla diagonale.
	 */
	int annulla_sotto_sopra_ii = 1;

	int min;int p;
	/* trovo il magg tra r e c */
	min = minimo(numrows, numcols);

	/* e'indisp fermarsi prima possibile a causa dell'annullamento di jordan */
	for(row = 0; row < min; row++)
	{
		annulla_sotto_sopra_ii = 1;
		column = row;
		if(a[row][column] == 0)
			annulla_sotto_sopra_ii = scambiariga(a, row, numrows, numcols);

		if(annulla_sotto_sopra_ii == 1) /*scambiariga ritorna 1 se trova e scambia*/
		{
			/* Devo annullare tutti gli elementi sotto a[l][l] */
			next_row = row + 1; 
			while(next_row < numrows )
			{
				/* calcolo il valore del coefficiente atto ad annullare l'elemento sotto quello di
				 * posto (l,l)
				 */
				coeff = a[next_row][row]/a[row][row];
				/* sottraggo agli elementi della riga k gli elementi della riga l moltiplicati 
				 * per il coefficiente m sopra calcolato. Il risultato e` che l'elemento sotto
				 * a[l][l] viene annullato.
				 */
				for(column = 0; column < numcols; column++)
					a[next_row][column]=a[next_row][column] - coeff * a[row][column];
				next_row++;
			}

			/* ora voglio annullare tutti gli elementi sopra a[l][l] */
			prev_row = row - 1;

			while(prev_row >= 0)
			{
				coeff = a[prev_row][row] / a[row][row];
				for(column = 0; column < numcols; column++)
					a[prev_row][column] = a[prev_row][column] - coeff * a[row][column];
				prev_row--;
			}

		}
		/*  else non fare nulla e passa al passo successivo: incrementa l*/
	}
}

/* restituisce 1 se ha effettuato lo scambio, 0 altrimenti.
 * a: puntatore alla matrice
 * l: riga al di sotto della quale cerco elementi non nulli
 * r, c: numero di righe e colonne della matrice a.
 */
int scambiariga(float a[R][C], int l, int r, int c)
{
	float temp[C]; /* memorizza la riga i-ma temporaneamente dentro il for */
	int i, j;
	/* i parte da 1 perche` cerco elementi non nulli sotto la riga l */
	for(i = 1; i < r - l; i++)
	{
		if( a[l+i][l] != 0 ) /*cerco l'elem sotto al l,l finche' ne trovo uno non nullo*/
		{
			for(j=0; j<c; j++)
			{
				temp[j] = a[l+i][j]; /* salvo la riga l+i-ma dentro temp */
				a[l+i][j] =a [l][j]; /* salvo nella l+i-ma riga la riga l-m */
				a[l][j] = temp[j];
			}
			return 1; /* ho effettuato lo scambio, ritorno */
		}
	}
	return 0;
}

void diagonale_unitaria(float m[R][C], int r, int c)
{
	int i=0;
	int j=0;
	float temp;

	for(i=0; i < minimo(r, c); i++)
	{
		temp=m[i][i];
		for(j=0; j<c; j++)
			m[i][j]=m[i][j]*(1/temp);
	}
}

int minimo(int a, int b)
{
	if(a < b)
		return a;
	return b;
}

